﻿using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Threading.Tasks;
using Windows.Media.FaceAnalysis;

namespace TestProject
{
    /// <summary>
    /// 얼굴 탐지 서비스
    /// </summary>
    public interface IFaceDetectionService
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 탐지 얼굴 리스트 구하기 - GetDetectedFaceList(stream)

        /// <summary>
        /// 탐지 얼굴 리스트 구하기
        /// </summary>
        /// <param name="stream">스트림</param>
        /// <returns>탐지 얼굴 리스트 태스크</returns>
        Task<IList<DetectedFace>> GetDetectedFaceList(Stream stream);

        #endregion
        #region 탐지 얼굴 비트맵 구하기 - GetDetectedFaceBitmap(stream, detectedFaceList, boxColor, strokeThickness)

        /// <summary>
        /// 탐지 얼굴 비트맵 구하기
        /// </summary>
        /// <param name="stream">스트림</param>
        /// <param name="detectedFaceList">탐지 얼굴 리스트</param>
        /// <param name="boxColor">박스 색상</param>
        /// <param name="strokeThickness">스트로크 두께</param>
        /// <returns>탐지 얼굴 비트맵</returns>
        Bitmap GetDetectedFaceBitmap(Stream stream, IList<DetectedFace> detectedFaceList, Color boxColor, int strokeThickness = 2);

        #endregion
    }
}